/* formDef.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef FORMDEF_H
#define FORMDEF_H

#include "formWidget.h"

#include <vector>

class FormDef {
public:
  FormDef();
  ~FormDef();

  static const FormDef *get_form(int form_id);
  static const FormDef *reread_form(int form_id);

  void record_db();
  bool look_up(int form_id);

  typedef vector<FormWidget> Widgets;
  Widgets _widgets;

  int _form_id;
  string _name;
  int _num_rows;
  int _num_columns;
  bool _homogeneous;
  int _x_size_pixels;
  int _y_size_pixels;
  bool _scrollbar;
  string _general_sql_command;
};

// Returns the form_id associated with the indicated form and the
// indicated table, or -1 if there is no associated child form.  For
// instance, this indicated the SongDialog form that should be pulled
// up when the user selects a track from a given CDDialog form.
int get_related_form_id(int form_id, TableID table_id);

#endif

