/* songDialog.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef SONGDIALOG_H
#define SONGDIALOG_H

#include "palomaDialog.h"
#include "artistEntry.h"
#include "songPlayerControls.h"
#include "form.h"
#include "dataset.h"

#include <gtk--.h>

class CDReader;

class SongDialog : public PalomaDialog {
public:
  SongDialog(const Dataset &data, int form_id, 
	     CDReader *cd_reader = NULL,
	     int track_index = -1);
  ~SongDialog();

  void set_load(bool load);
  bool get_load() const;

  virtual void record_db();

  void menu_open_cds();
  void menu_same_performer();

private:
  void ok_button_clicked();
  void cancel_button_clicked();

  void layout_window();

  Gtk_ItemFactory_MenuBar _menu;
  Gtk_ObjectHandle<Gtk_MenuBar> _menubar;
  Gtk_VBox _box1;
  Gtk_Label _name_label;
  Gtk_Entry _name_entry;
  Gtk_Label _performer_label;
  ArtistEntry _performer_entry;
  Gtk_Label _writer_label;
  ArtistEntry _writer_entry;
  Gtk_CheckButton _load_check;
  Gtk_Label _load_check_label;
  Gtk_Label _loaded_time_label;
  SongPlayerControls _player_controls;
  Form _form;
  Gtk_Button _ok_button;
  Gtk_Button _cancel_button;

  int _form_id;
  CDReader *_cd_reader;
  int _track_index;
  bool _load;
};

#endif

