/* server.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef SERVER_H
#define SERVER_H

#include <map>
#include <string>

class Player;

class Server {
public:
  Server(const string &sound_device, int port);
  ~Server();

  void main_loop();
  void set_active_player(Player *player);
  const string &get_sound_device() const;
  void close_connection(int socket);

  void clean_exit();

private:
  void accept_connection();

  string _sound_device;
  int _welcome_socket;
  Player *_active_player;
  bool _exit_flag;

  typedef map<int, Player *> Connections;
  Connections _connections;
  Connections _closed_connections;
};

#endif
